import xmlrpclib
from SimpleXMLRPCServer import SimpleXMLRPCServer

class ScarednessI:
	"""
	This is an interface class for the Scaredness measurement tool.
	This interface assumes that the getSweatRate() is being polled
	Roughly, it will set up a timer and call the submodules
	to get heart rate, sweat and speeck analysis sud scores
	Then it computes the scaredness out of that.
	The computed value is then sent over the PhysicalStatusI to the widget showing the info
	@author W.Pasman
	
	"""

	# @param patient is base object for this patient. 
	# @param heartrateinterface is object extending HeartRateI
	# @param sweatinterface is object extending SweatRateI
	# @param socket is a ready-to-send socket to send ScarednessMeasurement objects into
	# note that ScarednessI is an interface definition, so yo can still override functions
	# Recommended is to call this init function in any case to ensure correct parameters.
	def __init__(self,patient,heartrateinterface,sweatinterface):
		heartrate=null
		sweatrate=null
		socket=null
		refreshthread=null # non-null if refresh thread has been started
		sud=0 # latest SUD score that was calculated. minimum??
		
		if (!issubclass(patient,Patient)
			raise Exception("parameter patient is not a derived class of Patient")
		if (!issubclass(heartrateinterface,HeartRateI))
			raise Exception("parameter heartrateinterface is not an instance of HeartRateI")
		if (!issubclass(sweatinterface,SweatRateI))
			raise Exception("parameter sweatinterface is not an instance of SweatRateI")
		heartrate=heartrateinterface
		sweatrate=sweatinterface
		
		
		# find the socket to report to
		socket=Network.NetworkTools.getSocket("PhysStatusWidget",True,10)
		
		
		
	# this is the server thread
	# @param is unused at this moment.
	def runtheserver(self,*param):
		# initialize simple RPC server so that SUD scoring widget at therapist can reach us
		server = SimpleXMLRPCServer(("localhost", 9000))
		print "Listening on port"
		server.register_function(setSUD, "setSUD")
		server.serve_forever()
	
	# @param refreshRate is the number of times per second that a ScarednessMeasurement has to be
	@ sent over the socket.
	def setRefreshRate(refreshrate):
		raise Exception("getSweatRate has not been implemented!") 
	
		
	def getSUD():
		return sud
		
		
	def getHeartrate():
		return heartrate.getHeartRate()
		
	def getSweatRate():
		return sweatrate.getSweatRate()
		
	
	# sets the latest SUD score
	def setSUD(int SUD):
		
		